﻿/*
====== READ THIS ========
This code was created as a part of the seminar on 
flash game programing at the University of Munich (Ludwig-
Maximlians Universität.

The code may be used for educational purposes only. All
rights reserverd by the author.

Author: Max Maurer
E-Mail: max.maurer@ifi.lmu.de
(c) 2011
If you have any questions don't hasitate to contact me.
=========================
*/
package {
	import flash.display.MovieClip;
	public class Ball extends MovieClip {
		public var vx:Number;
		public var vy:Number;
		public var diam:Number;
		public var radius:Number;
		private const DAMP:Number = .98;
		private const BOUNCE:Number = -.6;
		private const MINSPEED:Number = .1;
		
		public function Ball(color:int):void {
			gotoAndStop(color);
			vx=vy=0;
			diam=width;
			radius=diam/2;
		}
		
		public function move(top:Number,right:Number,bottom:Number,left:Number):Boolean {
			if (vy==0 && vy==0) return false;
			vx *= DAMP;
			vy *= DAMP;
			x += vx;
			y += vy;
			if (x>right-radius) {
				x = right-radius;
				vx *= BOUNCE;
			} else if (x<left+radius) {
				x = left+radius;
				vx *= BOUNCE;
			}
			if (y>bottom-radius) {
				y = bottom-radius;
				vy *= BOUNCE;
			} else if (y<top+radius) {
				y = top+radius;
				vy *= BOUNCE;
			}
			var speed:Number = Math.sqrt(vx*vx+vy*vy);
			if (speed<MINSPEED) {
				vx = 0;
				vy = 0;
			}
			return true;
		}
		
		public function getColor():int {
			return currentFrame;
		}
		
		public function checkCollission(b2:Ball) {
			var b1:Ball = this;
			var dx:Number = b1.x-b2.x;
			var dy:Number = b1.y-b2.y;
			var dist = Math.sqrt(dx*dx+dy*dy);
			if (dist<diam) {
				var angle:Number = Math.atan2(dy, dx);
				var cosa:Number = Math.cos(angle);
				var sina:Number = Math.sin(angle);
				b1.x = b2.x+cosa*diam;
				b1.y = b2.y+sina*diam;
				var vx2 = cosa*b1.vx+sina*b1.vy;
				var vy1 = cosa*b1.vy-sina*b1.vx;
				var vx1 = cosa*b2.vx+sina*b2.vy;
				var vy2 = cosa*b2.vy-sina*b2.vx;
				b1.vx = cosa*vx1-sina*vy1;
				b1.vy = cosa*vy1+sina*vx1;
				b2.vx = cosa*vx2-sina*vy2;
				b2.vy = cosa*vy2+sina*vx2;
			}
		}
	}
}